******************************************************************
**								**
**		SEGA SATURN 16bit Data Loader ver0.1		**
**								**
**						by ӂȂۂ	**
**								**
**					since Feb 19 1997	**
******************************************************************

	.include	DOSCALL.MAC
	.include	IOCSCALL.MAC
	.include	fefunc.h
	.include	CONST.H

	.cpu	68000


	.offset	0

SSP_SAVE::		.ds.l	1

X_LENGTH::		.ds.b	4
Y_LENGTH::		.ds.b	4
ON_GET_NUMBER::		.ds.l	1			*-s temp
ON_FRAME_NUMBER::	.ds.b	12			*-s
NUMBER_TEMP::		.ds.b	4			*-a temp
FILE_NAME::		.ds.b	256

WORK_SIZE::

	.text
	.even

	lea.l	MYSP(pc),sp			*X^bN|Cgw̃AhX
	movea.l	sp,A1
	lea.l	(16,a0),a0
	suba.l	a0,a1
	move.l	a1,-(sp)
	move.l	a0,-(sp)
	DOS	_SETBLOCK			*
	addq.l  #8,sp

	lea.l	WORK(pc),a6

	move.l	#0,ON_GET_NUMBER(a6)
	move.l	#320,X_LENGTH(a6)
	move.l	#224,Y_LENGTH(a6)

**********************************************************
**		Comand Line Option Check		**
**********************************************************
C_CHECK::
	addq.l	#1,a2
	bsr	SKIPSP				*Xy[XXLbv
	tst.b	(a2)				*邩H
	beq	USAGE				*Ȃ USAGE

	cmpi.b	#'-',(a2)
	beq	OP_CHECK
	cmpi.b	#'/',(a2)
	beq	OP_CHECK
	bra	GETARG				*t@C

OP_CHECK::
	addq.l	#1,a2				*"/""-"̕a2i߂Ă
	move.b	(a2)+,d0			*ꕶo
	bsr	TOUPPER				*啶ɕϊĂ
	cmpi.b	#"S",d0
	beq	ON_FRAME_NUMBER_GET
	cmpi.b	#"A",d0
	beq	ABSOLUTE_NUMBER_GET
	bra	C_CHECK


ON_FRAME_NUMBER_GET::
	lea.l	ON_FRAME_NUMBER(a6),a0
	moveq.l	#0,d7

GET_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_NUMBER0_1
	cmpi.b	#TAB,(a2)			*space&tab͔΂
	beq	GET_NUMBER0_1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_NUMBER0

GET_NUMBER0_1::
	lea.l	ON_FRAME_NUMBER(a6),a0
	bsr	GET_NUMBER1
	move.l	d2,ON_GET_NUMBER(a6)
	bra	C_CHECK

ABSOLUTE_NUMBER_GET::
	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7

GET_X_NUMBER0::
	cmpi.b	#',',(a2)
	beq	GET_X_NUMBER1
	cmpi.b	#SPACE,(a2)
	beq	ONE_FRAME_ONLY			* -a ̎
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_X_NUMBER0

GET_X_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	cmpi.l	#511,d2
	bgt	OVER_X_NUMBER
	move.l	d2,X_LENGTH(a6)

	lea.l	NUMBER_TEMP(a6),a0
	moveq.l	#0,d7
	addq.l	#1,a2

GET_Y_NUMBER0::
	cmpi.b	#SPACE,(a2)
	beq	GET_Y_NUMBER1
	cmpi.b	#TAB,(a2)
	beq	GET_Y_NUMBER1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ
	addq.l	#1,d7				*JEg
	bra	GET_Y_NUMBER0

GET_Y_NUMBER1::
	lea.l	NUMBER_TEMP(a6),a0
	bsr	GET_NUMBER1
	cmpi.l	#511,d2
	bgt	OVER_Y_NUMBER
	move.l	d2,Y_LENGTH(a6)
	bra	C_CHECK

ONE_FRAME_ONLY::
	move.l	#320,X_LENGTH(a6)
	move.l	#224,Y_LENGTH(a6)
	bra	C_CHECK

GETARG::
	lea.l	FILE_NAME(a6),a0

GETARG0::
	tst.b	(a2)				*̏I[R[hH
	beq	GETARG1

	cmpi.b	#SPACE,(a2)
	beq	GETARG1
	cmpi.b	#TAB,(a2)			*space&tab͔΂
	beq	GETARG1
	move.b	(a2)+,(a0)+			*ȏオ܂œ]JԂ

	bra	GETARG0

GETARG1::
	clr.b	(a0)				*I[R[h

**********************************************************
**		READ .xvdFILE's HEAD 			**
**********************************************************

READ_FILE::
	move.w	#0,-(sp)			*READ only
	pea.l	FILE_NAME(a6)			*t@C
	DOS	_OPEN				*open
	addq.l	#6,sp

		tst.l	d0
		bmi	OPEN_ERROR

	move.w	d0,a5				*t@Cnha5֕ۑ

	move.l	X_LENGTH(a6),d0
	move.l	Y_LENGTH(a6),d1
	FPACK	__UMUL
	add.l	d0,d0				*d7:READ SIZE
	move.l	d0,d7

	move.l	d7,-(sp)
	DOS	_MALLOC				*$FF48
	addq.l	#4,sp

		move.l	d0,a0
		bmi	MALLOC_ERROR

	move.w	#0,-(sp)			*t@C擪̈ړ
	move.l	ON_GET_NUMBER(a6),-(sp)
	move.w	a5,-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SEEK_ERROR

	move.l	d7,-(sp)
	move.l	a0,-(sp)
	move.w	a5,-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	READ_ERROR
**********************************************************
**			To GV-RAM			**
**********************************************************

		clr.l	-(sp)
		DOS	_SUPER			* X[p[oCU[h
		move.l	d0,SSP_SAVE(a6)		* sspҔ
		addq.l	#4,sp

SQUARE::
	move.w	#$000C,d1			*ʃ[hw (C)MZL
	IOCS	_CRTMOD
	IOCS	_G_CLR_ON
	move.w	#$0110,d1
	IOCS	_CRTMOD
	move.w	#$0316,$00e8_0028
	move.w	#$0003,$00e8_2400
	move.w	#$002f,$00e8_2600

TO_GRAM::
	lea.l	$00c0_0000,a1
	move.l	Y_LENGTH(a6),d6
	subq.l	#1,d6

	move.l	X_LENGTH(a6),d7
	move.l	d7,d3
	subq.l	#1,d7				*d7:CULC_X_LENGTH(a6)

	move.l	#512,d4
	sub.l	d3,d4
	add.l	d4,d4				*d4:CULC_Y_LENGTH(a6)

	move.l	d7,d5
	bra	LP1

LP2::
		move.l	d5,d7

LP1::
		move.w	(a0)+,d0
						*SS:?_BBBBB_GGGGG_RRRRR
		rol.w	#6,d0			*   GGGGG_RRRRR_I_BBBBB
		move.w	d0,d1
		andi.w	#%11111_11111_0_00000,d0    GGGGG_RRRRR_0_00000
		lsl.w	#1,d1			*   GGGG_RRRRR_I_BBBBB_0
		andi.w	#%0000_00000_0_11111_0,d1   0000_00000_0_BBBBB_0
		or.w	d1,d0
						*68:GGGGG_RRRRR_BBBBB_I
		move.w	d0,(a1)+		*
		dbra	d7,LP1

		add.l	d4,a1			* =(512-X)x2
		dbra	d6,LP2

TO_GRAM_END::
		move.l	SSP_SAVE(a6),-(sp)	*
		DOS	_SUPER			* [U[[h
		addq.l	#4,sp			*

	bra	END

**********************************************************
**			SUB ROUTINE			**
**********************************************************

GET_NUMBER1::
	moveq.l	#0,d0
	moveq.l	#0,d2
	move.l	d7,d5
	subq.l	#1,d5

	subq.l	#2,d7		*dbrap-2
	move.l	d7,d6
1:
	move.l	d6,d7
	move.b	(a0)+,d0
		cmpi.b	#'0',d0			*0`9AA`ZȊO͒e
		bcs	IN_NUMBER_ERR		*
		cmpi.b	#'9'+1,d0		*
		bcc	IN_NUMBER_ERR		*
		subi.b	#$30,d0			*𐔎ɂ

		cmpi.l	#-1,d7
		ble	GET_NUMBER3
2:
	move.l	d0,d1			*d0=d1
	add.l	d1,d1			*d1=x2
	lsl.l	#3,d0			*d0=x8
	add.l	d1,d0			*d0=x10
	dbra	d7,2B

GET_NUMBER3::
	add.l	d0,d2
	moveq.l	#0,d0
	subq.l	#1,d6
	dbra	d5,1B
	rts


SKIPSP0::	addq.l	#1,a2
SKIPSP::
		cmpi.b	#SPACE,(a2)		*
		beq	SKIPSP0
		cmpi.b	#TAB,(a2)		*space&tab͔΂
		beq	SKIPSP0
		rts

TOUPPER::
		cmpi.b	#"a",d0			*Ȃ啶
		bcs	TOUPPER0
		cmpi.b	#"z"+1,d0
		bcc	TOUPPER0
		subi.b	#$20,d0
TOUPPER0::
		rts

**********************************************************
**			Error Routine			**
**********************************************************
USAGE::
	pea.l	USAGE_MSG(pc)
	bra	DISP_ABORT

IN_NUMBER_ERR::
	pea.l	IN_NUMBER_ERR_MSG(pc)
	bra	DISP_ABORT

OVER_X_NUMBER::
	pea.l	OVER_X_NUMBER_MSG(pc)
	bra	DISP_ABORT

OVER_Y_NUMBER::
	pea.l	OVER_Y_NUMBER_MSG(pc)
	bra	DISP_ABORT

**********************************************************
**			DOS CALL ERROR			**
**********************************************************
OPEN_ERROR::
	pea.l	OPEN_ERR_MSG(pc)
	bra	DISP_ABORT

MALLOC_ERROR::
	pea.l	MALLOC_ERROR_MSG(pc)
	bra	DISP_ABORT

SEEK_ERROR::
	pea.l	SEEK_ERR_MSG(pc)
	bra	DISP_ABORT

READ_ERROR::
	pea.l	READ_ERR_MSG(pc)
*	bra	DISP_ABORT

DISP_ABORT::
	DOS	_PRINT			*$FF09
	addq.l	#4,sp

END:
	DOS	_EXIT


	.data
	.even

**********************************************************
**			DATA ARIA			**
**********************************************************
USAGE_MSG::
	.dc.b	'SEGA SATURN 16bit Data Loader ver0.1',CR,LF
	.dc.b	'		Programed by ӂȂۂ Feb 20 1998',CR,LF
	.dc.b	CR,LF
	.dc.b	'usage : ssl <option> datafile',CR,LF
	.dc.b	'option: -s[num] : num = Skip byte (32bit)',CR,LF
	.dc.b	'      : -a[x,y] : x,y = X[Y] Length(0x[y]511)',CR,LF,0

OPEN_ERR_MSG::		.dc.b	'DOS _OPEN Error!',CR,LF,0
MALLOC_ERROR_MSG::	.dc.b	'DOS _MALLOC Error!',CR,LF,0
SEEK_ERR_MSG::		.dc.b	'DOS _SEEK Error!',CR,LF,0
READ_ERR_MSG::		.dc.b	'DOS _READ Error!',CR,LF,0

IN_NUMBER_ERR_MSG::	.dc.b	'Option Number Error!',CR,LF,0
OVER_X_NUMBER_MSG::	.dc.b	'Over X Length: 0X_length511',CR,LF,0
OVER_Y_NUMBER_MSG::	.dc.b	'Over Y Length: 0Y_Length511',CR,LF,0

	.bss
	.even

WORK::
	.ds.b	WORK_SIZE

	.stack
	.even

MYSTACK::
	.ds.l	256		*X^bN̈
MYSP::

	.end
